precision highp float;       	// Set the default precision to highp.
//uniform vec3 u_LightPos;      // The position of the light in eye space.
uniform sampler2D u_Texture;
  
varying vec2 v_TexCoordinate;   // Interpolated texture coordinate per fragment.

uniform int mode;               // 0: Normal; 1: Fisheye

uniform float elevation;
uniform float azimuth;
uniform float zoomFactor;
uniform float sinphai0;         //== sin(elevation+PI/2.0);
uniform float cosphai0;         //== cos(elevation+PI/2.0);
uniform float screenRatio;      //== screenWidth/screenHeight

// The entry point for our fragment shader.
void main()                    		
{
    if(mode == 1) {
        vec2 textureCoordinateToUse = v_TexCoordinate;

        float xo;
        float yo;
        float xi;
        float yi;
        float x;
        float y;
        float z;
        float x1;
        float y1;
        float z1;
        float sitao;
        float phaio;
        float phaii;
        float ri;
        float ris;
        float cosphaii;
        float sinphaii;
        float PI = 3.14159265358979;
        float RS = 1.0;
        vec2 center = vec2(0.5, 0.5);

        textureCoordinateToUse -= center;

        //cosphai0 = cos(elevation+PI/2.0);
        //sinphai0 = sin(elevation+PI/2.0);

        xi = textureCoordinateToUse.x;
        yi = textureCoordinateToUse.y/screenRatio;

        ri = sqrt( yi*yi + xi*xi );

        if( zoomFactor == 1.0 )
        {
            ris = sqrt( ri*ri + RS*RS );
            cosphaii = ri / ris;
            sinphaii = RS / ris;
        }
        else
        {
            phaii = atan(ri/RS) * zoomFactor + 9.0*ri/RS * (1.0 - zoomFactor);
            phaii = PI/2.0 - phaii;
            sinphaii = sin( phaii );
            cosphaii = cos( phaii );
        }

        if( PI/2.0 - phaii > PI || PI/2.0 - phaii < -PI )
        {
            gl_FragColor = vec4( 0, 0, 0, 0 );

        } else {

            z = sinphaii;
            y = cosphaii * xi/ri; //sin(sitai);
            x = cosphaii * yi/ri; //cos(sitai);

            x1 = x * cosphai0 + z * sinphai0;
            z1 = z * cosphai0 - x * sinphai0;
            y1 = y;

            phaio = asin( z1 );

            //sitao = atan2( y1, x1 ) + azimuth;
            if( x1 == 0.0 )
            {
                if( y1 >= 0.0 )
                    sitao = PI/2.0;
                else
                    sitao = -PI/2.0;
            }
            else
            {
                sitao = atan( y1/x1 );
            }

            if( x1 < 0.0 )
            {
                if( y1 >= 0.0 )
                    sitao += PI;
                else
                    sitao -= PI;
            }
            sitao -= azimuth;
            //

            if ( sitao > PI ) {
                sitao -= 2.0 * PI;
            }
            if ( sitao < -PI ) {
                sitao += 2.0 * PI;
            }

            xo = sitao * RS / (2.0*PI);
            yo = - phaio * RS / PI;

            textureCoordinateToUse = vec2( xo, yo );


            textureCoordinateToUse += center;
            gl_FragColor = texture2D(u_Texture, textureCoordinateToUse);
        }
    }
    else {
        gl_FragColor =  texture2D(u_Texture, v_TexCoordinate);
    }
}                                                                     	

